/************************************************************************/
/* Headers for functions for manipulating distribution laws.		*/
/************************************************************************/
#ifndef _LAW_H
#define _LAW_H

#include "real_list.h"

typedef struct LAW_DESC {
	char	Name;
	double*	Parameters;
  	struct LAW_DESC	**Law_Parameters;	/* table pour lois "annexes */
} *Law_Desc;

typedef struct LAW_LIST {
	Law_Desc	Val;
	struct LAW_LIST *Next;
} *Liste_Loi;


/* Definitions for printing styles */
#define NO_PRINT_MODE		0
#define	DEFAULT_PRINT_MODE	1
#define	NORMAL_PRINT_MODE	1
#define QNAP_PRINT_MODE		2
#define PROSIT_PRINT_MODE	3
#define MMPP_PRINT_MODE		4

double		Mean( Law_Desc Loi );
double		Moment( Law_Desc Loi, int Order );
double		Laplace( Law_Desc Loi, double s );
double		DLaplace( Law_Desc Loi, double s );
double		CDF( Law_Desc Loi, double x );
void		Write_Law( FILE *Stream, Law_Desc Loi, int Mode );
Law_Desc	New_Law( void );
Law_Desc	Copy_Law( Law_Desc Loi );
Law_Desc 	Rescale_Law( Law_Desc Loi, double Factor );
Law_Desc 	Parse_Law( char	Nom, Liste_Reel Params, Liste_Reel Params2,
			   Liste_Loi The_SubLaws );
Liste_Loi 	Append_Law( Liste_Loi	Law_List, Law_Desc New_Law );
void		Free_Law( Law_Desc The_Law );

/* shortcut for printing, mostly out of backwards compatibility */
#define fprint_law(x)	Write_Law( stdout, x, NORMAL_PRINT_MODE )

#endif
