/************************************************************************/
/* Module containing functions for manipulating lists of reals.		*/
/* Provides:								*/
/*	Liste_Reel Append_Real( Liste_Reel List, double x );		*/
/*	Liste_Reel Expand_Real_List( double x, int n );			*/
/*      Liste_Reel Concat_Real_Lists( Liste_Reel L1, Liste_Reel L2 );	*/
/*	void Free_Real_List( Liste_Reel List );				*/
/************************************************************************/

#include "real_list.h"

Liste_Reel Append_Real( Liste_Reel Real_List, double New_Real )
{
  Liste_Reel	The_List;

  The_List = (Liste_Reel) malloc( sizeof( struct REAL_LIST ) );

  if ( The_List != NULL ) {
    The_List->Val = New_Real;
    The_List->Next = Real_List;
  }
  else {
    E_MEM("Real");
  }

  return( The_List );
}

Liste_Reel Concat_Real_Lists( Liste_Reel L1, Liste_Reel L2 )
{
  Liste_Reel	L_Scan;

  if ( L1 == (Liste_Reel)NULL ) {
    return L2;
  }
  else if ( L2 == (Liste_Reel)NULL ) {
    return L1;
  }
  else {
    for( L_Scan = L1; ( L_Scan->Next != NULL ); L_Scan=L_Scan->Next );
    L_Scan->Next = L2;
    return L1;
  }
}

Liste_Reel Expand_Real_List( double The_Real, int Number )
{
  Liste_Reel	The_List;
  Liste_Reel	New_Elt;
  boolean	Mem_Ok = TRUE;
  int		i;

  The_List = (Liste_Reel)NULL;

  for ( i=0; Mem_Ok && (i<Number); i++ ) {
    New_Elt = (Liste_Reel) malloc( sizeof( struct REAL_LIST ) );

    if ( New_Elt != NULL ) {
      New_Elt->Val = The_Real;
      New_Elt->Next = The_List;
      The_List = New_Elt;
    }
    else {
      E_MEM("Real");
      Mem_Ok = FALSE;
      The_List = (Liste_Reel)NULL;
    }
  }

  return( The_List );
}

void Free_Real_List( Liste_Reel 	The_List )
{
  Liste_Reel	L_Scan;
  Liste_Reel	M_Scan;

  for ( L_Scan = The_List; L_Scan != NULL; ) {
    M_Scan = L_Scan;
    L_Scan = L_Scan->Next;
    free( (char*) M_Scan );
  }
}
