/* Structures de donnees specifiques des outils de type "EG"	 	*/
/* version 5 								*/

#include "global.h"

#ifndef _EG_H_
#define _EG_H_
/************************************************************************/
/* structures rather for Event Graphs 					*/
/************************************************************************/
typedef struct PLACE_DESC {
  int		Place_Id;	/* Own id betw. 0 and Nb_Places-1	*/
  int		Trans_Id;	/* numero of output trans 		*/
  int		Input_Id;	/* numero of input trans		*/
  char		*Name;
  Law_Desc	Place_Law;
  int		Init_Pop;
  double	*Lag_Times;
  char		*Data1;
  char		*Data2;		/* for ex for names of links	*/
} *Place_Desc;

typedef struct PLACE_LIST {
  Place_Desc 		Val;
  struct PLACE_LIST 	*Next;
} *Liste_Place;

typedef struct LAYER_DESC {
  int	Nb_Nodes;
  int	*Node_Id;
} *Layer_Desc;

typedef struct TRANS_DESC {
  int		Trans_Id;	/* Own id between 1 and Size	*/
  char		*Name;		/* Name (optionnal)		*/
  char		*Data;		/* "data" (optionnal)		*/
  Law_Desc	Trans_Law;	/* Firing time distribution	*/
  int		Outdegree;	/* Nb of output places		*/
  Liste_Place	Outputs;	/* List of output places	*/
  int		Indegree;	/* Nb of input places 		*/
  Liste_Place	Inputs;		/* List of input places		*/
} *Trans_Desc;

typedef struct TRANS_LIST {
	Trans_Desc 	Val;
	struct TRANS_LIST *Next;
} *Liste_Transition;

typedef struct EventGraph {
  int		Size;		/* number of transitions	*/
  int		Nb_Places;
  Trans_Desc	*T;		/* Table of transitions		*/
  Place_Desc	*P;		/* Table of places		*/
  int		Nb_Layers;	/* Layers wrt empty places	*/
  Layer_Desc	*Level;		/* Table of layers		*/
  int		Max_Pop_Init;
} EventGraph;

#endif
