%{
extern double atof(const char*);
extern int    atoi(const char*);
extern char   *strncpy(char *, const char*, size_t);

int    EGL_lineno = 1;
%}

%%
Taille		return( SIZE );
Size		return( SIZE );
Duree		return( TMAX );
Length		return( TMAX );
B		return( BERN );
C		return( CST  );
D		return( DISC );
E		return( EXPO );
G		return( GEOM1 );
g		return( GEOM0 );
H		return( HEXP );
L		return( LOGNO );
O		return( ONOFF );
p		return( PARETO );
IPP		return( IPP );
R		return( ERLG );
U		return( UNIF );
W		return( WEIBULL );
\<\-		return( AFFECT );
\[		return( PARB );
\]		return( PARE );
[0-9]+		{
			yylval.ival = atoi(yytext);
			return( INTGR );
		}
[0-9]+\.[0-9]*	{
			yylval.rval = atof(yytext);
			return( REAL );
		}
\"[ a-zA-Z][ a-zA-Z0-9_\.!|]*\" {
			yylval.sval = malloc( (yyleng-1)*sizeof(char) );
			yylval.sval = strncpy( yylval.sval, &(yytext[1]),
						yyleng-2 );
			yylval.sval[yyleng-2] = '\0';
			return( STRING );
		}
[,]		return( SEP );
\;		return( ENDINSTR );
\#.*$		;
[ \t]+		;
[\n]            {
                        EGL_lineno++;
                }
.		printf("Illegal character: %s\n", yytext);
