/* Declaration of interaction graph structures and methods */

#ifndef _I_GRAPH_H
#define _I_GRAPH_H

#include "boolmat.h"
#include "bernoulli.h"

typedef struct INTERACTION_GRAPH {
  int		Size;		/* Nb of Nodes in graph 		*/
  Boolean_Matrix	A;	/* Adj Matrix	 			*/
  double	*Weight;	/* Weights of each node.	 	*/
  double	*Proba;		/* Probabilities of each node.	 	*/
  double	*Pr_Cum;        /* Partial Sums of Proba. 		*/
  int		*Permut;	/* Permutation to optimize drawing of 	*/
				/* probas (currently not used)		*/
} *Interaction_Graph;

/* Methods */
Interaction_Graph New_Interaction_Graph( int Matrix_Size );
void Free_Interaction_Graph( Interaction_Graph );
Interaction_Graph Read_Interaction_Graph( FILE* Input );
boolean Is_Uniform( Interaction_Graph );
Bernoulli_Product IG_To_BP( Interaction_Graph );

#endif
