%{
extern double atof(const char *);
extern int    atoi(const char *);
extern char   *strncpy(char *,char *, int);
int	      Tetris_lineno = 1;
%}

%%
Columns		return( COLUMNS );
Piece		return( PIECE );
Weight		return( WEIGHT );
Color		return( COLOR );
LoProf		return( LOPROF );
HiProf		return( HIPROF );
eps		return( EPS );

[0-9]+		{
			yylval.ival = atoi(yytext);
			return( INTGR );
		}
[0-9]+\.[0-9]*	{
			yylval.rval = atof(yytext);
			return( REAL );
		}
[\#][a-zA-Z0-9 _]*$ {
			yylval.sval = malloc( (yyleng+1)*sizeof(char) );
			yylval.sval = strncpy( yylval.sval, yytext,
						yyleng );
			yylval.sval[yyleng] = '\0';
			/* if ( Debug ) {
				printf("Got string [%s]\n", yylval.sval );
			} */
			return( STRING );
		}
\#.*$		;
[ \t]+		;
[\n]		{
			Tetris_lineno++;
		}
.               printf("Illegal caracter: %s\n", yytext);
