/* Definitiona related to (maxplus) sparse matrix manipulations */

#ifndef _SPMAT_H
#define _SPMAT_H

#include "fullmat.h"

/* types of matrices for initialization */
#define NONE		0
#define	ZERO		1
#define	IDENTITY	2
#define	ONE		3

typedef struct SP_MAXPLUS_MATRIX {
  int		Rows;
  int		Cols;
  int		*Nb_Elts; 	/* Table of numbers of elements in rows */
  int		**Elts;		/* Ids of neighboring states		*/
  double	**Vals;		/* Values associated.			*/
} *SP_MaxPlus_Matrix;

typedef struct SP_MAXPLUS_VECTOR {
  int		Size;
  double	*Vals;
} *SP_MaxPlus_Vector;

SP_MaxPlus_Matrix New_SP_MaxPlus_Matrix(int Rows,int Cols,int Mode);
void Free_SP_MaxPlus_Matrix(SP_MaxPlus_Matrix);
SP_MaxPlus_Vector New_SP_MaxPlus_Vector(int Size,int Mode);
void Free_SP_MaxPlus_Vector(SP_MaxPlus_Vector);
boolean Init_SP_MaxPlus_Matrix(SP_MaxPlus_Matrix,int Mode);
SP_MaxPlus_Matrix Make_SP_MaxPlus_Matrix(int,int,double**);
Full_MaxPlus_Matrix Convert_SP_Matrix_To_Full(SP_MaxPlus_Matrix);
double  Get_SP_Matrix_Entry(SP_MaxPlus_Matrix,int,int);
boolean Set_SP_Matrix_Entry(SP_MaxPlus_Matrix,int,int,double);
boolean SP_Read_Full_Matrix_Entry(FILE*,SP_MaxPlus_Matrix,int,int);
boolean SP_Read_SP_Matrix_Entry(FILE*,SP_MaxPlus_Matrix);
boolean SP_Read_Full_Matrix(FILE*,SP_MaxPlus_Matrix);
boolean SP_Read_SP_Matrix(FILE*,SP_MaxPlus_Matrix);
boolean SP_Read_MaxPlus_Matrix(FILE*,SP_MaxPlus_Matrix);
void SP_Write_Matrix(SP_MaxPlus_Matrix,FILE*,int,char*);
void SP_Write_Vector(SP_MaxPlus_Vector,FILE*,int);
void SP_VM_Mult(SP_MaxPlus_Vector,SP_MaxPlus_Matrix,SP_MaxPlus_Vector);
void SP_MV_Mult(SP_MaxPlus_Matrix,SP_MaxPlus_Vector,SP_MaxPlus_Vector);
double SP_Matrix_Norm(SP_MaxPlus_Matrix);
double SP_Vector_Norm(SP_MaxPlus_Vector);
double SP_Vector_Min(SP_MaxPlus_Vector);

#endif
