/* Declaration of tetris structures and methods */

#ifndef _TETRIS_H
#define _TETRIS_H

#include <stdio.h>
#include "boolean.h"

#define EPSILON -2147483647

/* Structures and types declarations */
typedef struct PIECE_DESC {
  int	Number;
  int	Nb_Columns;
  int	*LoProf;
  int	*HiProf;
  char	*Color;
} *Piece_Desc;

typedef struct TETRIS {
  int		Nb_Columns;
  int		Nb_Pieces;
  Piece_Desc 	*Piece;
  double	*Weight;
  char		**Color;
} *Tetris;

/* local structures useful for parsing only */
typedef struct SPARSE_INT_ARRAY {
  int	Nb_Indexes;
  int	*Indexes;
  int  *Values;
} *Sparse_Int_Array;
   
typedef struct BIPOINT {
  int Col;
  int Height;
} BiPoint;

typedef struct PIECE_LIST {
  Piece_Desc	Val;
  struct PIECE_LIST *Next;
} *Piece_List;

/* Methods */
Tetris New_Tetris( int Nb_Columns, int Nb_Pieces, Piece_Desc *List );
void Free_Tetris( Tetris );
Piece_Desc New_Piece( int Nb_Columns );
Piece_Desc Copy_Piece(Piece_Desc);
void Free_Piece(Piece_Desc);
void Set_Colors(Tetris);
Tetris Read_Tetris(char *);
void Write_Tetris(Tetris,FILE*);
void Write_Piece(Piece_Desc,FILE*);
void Normalize_Weights(Tetris);
#endif
