%{

#include "pn.h"

#define YYDEBUG 1

extern boolean		Debug;
extern PetriNet		*The_Petri_Net;

extern PetriNet 	*Parse_PN();
extern Tr_Des	 	*Parse_Transition();
extern Tr_Des	 	*Add_Trans_Sons();
extern Pl_Des		*Parse_Place();
extern Liste_Link	Parse_Place_Head();	/* reutilisation abusive*/
						/* du type...		*/
extern Liste_Link	Parse_Link();
extern Subm_Des		*Parse_Submodel();
extern Pl_Des		*Add_Place_Sons();
extern Population	*Parse_Init_Pop();
extern Law_Desc		Parse_Law(char Nom, Liste_Reel Params, 
				  Liste_Reel Params2, Liste_Loi The_SubLaws);
extern Routing_Desc	Parse_Routing();
extern Listes		Append_Transition();
extern Listes		Append_Place();
extern Liste_Subm	Append_Submodel();
extern Liste_Subm	Read_Submodel_Files();
extern Liste_Reel	Append_Real();
extern Liste_Reel	Concat_Real_Lists();
extern Liste_Reel	Expand_Real_List();
extern Liste_Entier	Append_Integer();
extern Liste_Link	Append_Link();
extern Liste_Loi	Append_Law();
extern Liste_Address	Append_Address();
extern Address		Parse_Address();
extern Binding		Parse_Binding();
extern Binding		Make_Binding();
extern Binding		Append_Binding();
%}

%start reseau

%union{
	int		ival;
	double		rval;
	char		*sval;
	PetriNet	*un_reseau;
	Law_Desc	loi;
	Pl_Des		*place;
	Tr_Des		*transition;
	Subm_Des	*submodel;
  	Routing_Desc	routing;
	Parametres	params;
	Listes		ptlist;
	Population	*pop;
  	Liste_Subm	slist;
	Liste_Reel	rlist;
  	Liste_Entier	ilist;
  	Liste_Link	llist;
	Liste_Loi	Llist;
  	Address		aval;
  	Liste_Address	alist;
  	Binding		bval;
}

%token	<ival>		TSIZE PSIZE TMAX AFFECT INTGR
%token	<ival>		SEP ENDINSTR SLASH	/* pas de valeur, en fait */
%token	<ival>		RAND CYCL COMP PRIO	/* pas de valeur non plus */
%token	<ival>		TRANS PLACE SUBMO	/* ni ceux-ci...	  */
%token	<ival>		INHIB			/* ni lui.		  */
%token  <ival>		EXPORT IS IN OUT BIND	/* ni eux non plus.	  */
%token  <ival>		SUBM INFILE		/* sans parler d'eux.	  */
%token	<ival>		PARB PARE REP
%token	<rval>		REAL
%token	<sval>		STRING NAME
%token	<loi>		EXPO ERLG BERN GEOM0 GEOM1 UNIF CST DISC ONOFF IPP HEXP
%token  <loi>		LOGNO PARETO WEIBULL

%type	<un_reseau>	reseau
%type	<ptlist>	liste_trucs
%type	<transition>	transition_dcl a_transition
%type	<params>	declarations
%type   <slist>		submodel_dcl submodel_list
%type   <submodel>	one_submodel
%type	<ival>		trans_id place_id
%type   <ival>		tag
%type	<loi>		loi_dcl
%type	<place>		place_dcl a_place
%type	<pop>		pop_dcl
%type	<ival>		t_taille_dcl p_taille_dcl duree_dcl
%type	<routing>	routing_dcl
%type	<rlist>		real_list
/* %type	<ilist>		int_list  */
%type	<llist>		link_list one_link one_link_descr place_head
%type   <Llist>		law_list
%type	<sval>		name
%type   <aval>          address io_address
%type	<alist>		address_list
%type   <bval>		a_binding binding_list binding_dcl io_dcl io_list one_io

%%

reseau :	declarations liste_trucs io_dcl
		{
		  	The_Petri_Net = 
			  Parse_PN( $1.T_Size, $1.P_Size, $1.Nb_Firings, 
				    $2->Places, $2->Transitions, 
				    $3, (Liste_Subm)NULL, (Binding)NULL );
			if ( Debug )
			  printf("Reseau ok\n");
		}
/* 		| */
/* 		declarations io_dcl liste_trucs */
/* 		{ */
/* 		  	$$ = Parse_PN( $1.T_Size, $1.P_Size, $1.Nb_Firings,  */
/* 				       $3->Places, $3->Transitions,  */
/* 				       $2, (Liste_Subm)NULL, (Binding)NULL ); */
/* 			if ( Debug ) */
/* 			  printf("Reseau ok\n"); */
/* 		} */
/* 		| */
/* 		declarations io_dcl submodel_dcl liste_trucs binding_dcl */
/* 		{ */
/* 		  	$$ = Parse_PN( $1.T_Size, $1.P_Size, $1.Nb_Firings,  */
/* 				       $4->Places, $4->Transitions,  */
/* 				       $2, $3, $5 ); */
/* 			free( $3 ); */
/* 			if ( Debug ) */
/* 			  printf("Reseau ok\n"); */
/* 		} */
		|
		declarations submodel_dcl liste_trucs binding_dcl io_dcl
		{
		  	The_Petri_Net = 
			  Parse_PN( $1.T_Size, $1.P_Size, 0,
				    $3->Places, $3->Transitions, 
				    $5, $2, $4 );
			free( $2 );
			if ( Debug )
			  printf("Reseau ok\n");
		}		
		;

declarations :	t_taille_dcl p_taille_dcl duree_dcl
		{	$$.T_Size = $1;
			$$.P_Size = $2;
			$$.Nb_Firings = $3;
			printf("Warning: duration declaration is obsolete. Ignored.\n");
		}
		| t_taille_dcl p_taille_dcl
		{	$$.T_Size = $1;
			$$.P_Size = $2;
			$$.Nb_Firings = 0;
		}
		;

t_taille_dcl :	TSIZE AFFECT INTGR
		{	$$ = $3;
		}
		;
		
p_taille_dcl :	PSIZE AFFECT INTGR
		{	$$ = $3;
		}
		;
		
duree_dcl :	TMAX AFFECT INTGR
		{	$$ = $3;
		}
 		;

io_dcl :	EXPORT io_list
		{
			$$ = $2;
		}
		| /* nil */
		{
			$$ = (Binding)NULL;
		}
		;

io_list :	io_list one_io
		{
			$$ = Append_Binding( $1, $2 );
		}
		|
		one_io
		{
			$$ = Append_Binding( $1, (Binding)NULL );
		}
		;

one_io :	io_address IS address ENDINSTR
		{
			$$ = Make_Binding( $1, $3, (Liste_Link)NULL );
		}
		;

submodel_dcl :	submodel_list
		{
		  /* $$ = Read_Submodel_Files( $1 ); */
		  $$ = $1;
		}
		;

submodel_list : one_submodel
		{
			$$ = Append_Submodel( (Liste_Subm)NULL, $1 );
		}
		|
		submodel_list one_submodel 
		{
			$$ = Append_Submodel( $1, $2 );
		}
		| /* nil */ 
		{ 
			$$ = (Liste_Subm)NULL;
		}
		;

one_submodel :	SUBM INTGR INFILE STRING ENDINSTR
		{
			$$ = Parse_Submodel( $2, $4, "" );
		}
		|
		SUBM INTGR name INFILE STRING ENDINSTR
		{
			$$ = Parse_Submodel( $2, $5, $3 );
		}
		;

liste_trucs :
		liste_trucs a_transition
		{	$$ = Append_Transition( $1, $2 );
		}
		| liste_trucs a_place
		{	$$ = Append_Place( $1, $2 );
		}
		| a_transition
		{	$$ = Append_Transition( (Listes)NULL, $1 );
		}
		| a_place
		{	$$ = Append_Place( (Listes)NULL, $1 );
		}
		;

tag:
		PARB INTGR PARE
		{
			$$ = $2;
		}
		| /* nil */
		{
			$$ = 0;
		}
		;
			
  
a_transition:
		tag TRANS transition_dcl SEP link_list ENDINSTR
		{ 	$$ = Add_Trans_Sons( $3, $5 );
		}
		| tag TRANS transition_dcl ENDINSTR
		{ 	$$ = $3;
		}
		;

transition_dcl:
		trans_id loi_dcl
		{ 	$$ = Parse_Transition( $1, $2, "", "" );
		}
		| trans_id name loi_dcl
		{ 	$$ = Parse_Transition( $1, $3, $2, "" );
		}
		| trans_id name name loi_dcl
		{ 	$$ = Parse_Transition( $1, $4, $2, $3 );
		}
		;

a_place :	
		tag PLACE place_dcl SEP link_list ENDINSTR
		{	$$ = Add_Place_Sons( $3, $5 );
		}
		| tag PLACE place_dcl ENDINSTR
		{	$$ = $3;
		}
		;

place_dcl :	place_head loi_dcl pop_dcl routing_dcl
		{	$$ = Parse_Place( $1, $2, $3, "", $4 );
			if ( Debug )
				printf(" (%c)\n", 
				       ($4==NULL? '-' : $4->Type ) );
		}
		| place_head name loi_dcl pop_dcl routing_dcl
		{	$$ = Parse_Place( $1, $3, $4, $2, $5 );
			if ( Debug )
				printf("(a=\"%s\") (%c)\n", 
				       ($2==NULL? "<nil>" : $2), 
				       ($5==NULL? '-' : $5->Type ) );
		}
		| place_head loi_dcl pop_dcl
		{	$$ = Parse_Place( $1, $2, $3, "", 
						(Routing_Desc) NULL );
			if ( Debug )
				printf("\n");
		}
		| place_head name loi_dcl pop_dcl
		{	$$ = Parse_Place( $1, $3, $4, $2,
						(Routing_Desc) NULL );
			if ( Debug )
				printf("(a=\"%s\")\n",
				       ($2==NULL? "<nil>" : $2) );
		}
		;

place_head :	place_id 
		{	$$ = Parse_Place_Head( $1, "" );
			if ( Debug )
				printf("Place %d reconnue ", $1 );
		}
		| place_id name
		{	$$ = Parse_Place_Head( $1, $2 );
			if ( Debug )
				printf("Place %s [%d] reconnue ",$2, $1);
		}

trans_id :	INTGR
		;

place_id :	INTGR
		;

name :		STRING
		{	$$ = $1;
		}

loi_dcl : 	EXPO real_list
		{	$$ = Parse_Law( 'E', $2, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		}
		| CST real_list
		{	$$ = Parse_Law( 'C', $2, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		}
		| BERN real_list
		{	$$ = Parse_Law( 'B', $2, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		}
		| GEOM0 real_list
		{	$$ = Parse_Law( 'g', $2, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		}
		| GEOM1 real_list
		{	$$ = Parse_Law( 'G', $2, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		}
		| ERLG INTGR real_list
		{	$$ = Parse_Law( 'R', Append_Real( $3, (double)$2 ),
					(Liste_Reel)NULL,
					(Liste_Loi)NULL );
		}
		| UNIF real_list
		{	$$ = Parse_Law( 'U', $2, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		}
		| LOGNO real_list
		{	$$ = Parse_Law( 'L', $2, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		}
		| PARETO real_list
		{	$$ = Parse_Law( 'p', $2, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		}
		| WEIBULL real_list
		{	$$ = Parse_Law( 'W', $2, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		}
		| DISC PARB real_list PARE PARB real_list PARE
		{	$$ = Parse_Law( 'D', $3, $6,
					(Liste_Loi)NULL );
		}
		| HEXP real_list
		{	$$ = Parse_Law( 'H', $2, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		}
		| ONOFF real_list
		{	$$ = Parse_Law( 'O', $2, (Liste_Reel)NULL,
					(Liste_Loi)NULL );
		}
		| IPP PARB REAL SEP law_list PARE
		{	$$ = Parse_Law( 'P', 
					Append_Real( (Liste_Reel)NULL, $3),
					(Liste_Reel)NULL, $5 );
		}
		;

pop_dcl :	INTGR real_list
		{	$$ = Parse_Init_Pop( $1, $2 );
		}
/* 		| INTGR  */
/* 		{	$$ = Parse_Init_Pop( $1, (Liste_Reel)NULL ); */
/* 		} */
		;

routing_dcl :
		RAND PARB real_list PARE
		{	$$ = Parse_Routing( 'R', $3, (Liste_Address)NULL );
		}
		| CYCL PARB address_list PARE
		{	$$ = Parse_Routing( 'D', (Liste_Reel)NULL, $3 );
		}
		| COMP PRIO PARB address_list PARE
		{	$$ = Parse_Routing( 'P', (Liste_Reel)NULL, $4 );
		}
		| COMP
		{	$$ = Parse_Routing( 'C', (Liste_Reel)NULL, 
							(Liste_Address)NULL );
		}
		;
		
real_list :	PARB REAL REP INTGR PARE
		{	$$ = Expand_Real_List( $2, $4 );
		}
		| real_list REAL
		{	$$ = Append_Real( $1, $2 );
		}
		| REAL
		{	$$ = Append_Real( (Liste_Reel)NULL, $1 );
		}
		| /* empty */
		{	$$ = (Liste_Reel)NULL;
		}
		;

law_list :	loi_dcl
		{	$$ = Append_Law( (Liste_Loi)NULL, $1 );
		}
		| law_list SEP loi_dcl
		{	$$ = Append_Law( $1, $3 );
		}
		;

/* int_list :	INTGR */
/* 		{	$$ = Append_Integer( (Liste_Entier)NULL, $1 ); */
/* 		} */
/* 		| int_list INTGR */
/* 		{	$$ = Append_Integer( $1, $2 ); */
/* 		} */
/* 		; */

link_list :	one_link
		{	$$ = Append_Link( (Liste_Link)NULL, $1 );
		}
		| link_list SEP one_link
		{	$$ = Append_Link( $1, $3 );
		}
		;

one_link :	one_link_descr
                {       $$ = $1;
		}
                | one_link_descr INHIB
                {       $$ = $1;
			$$->Is_Inhibitor = TRUE;
		}
                ;

/*
one_link_descr :INTGR
		{	$$ = Parse_Link( $1, 1, "" );
		}
		| INTGR INTGR
		{	$$ = Parse_Link( $1, $2, "" );
		}
		| INTGR name
		{	$$ = Parse_Link( $1, 1, $2 );
		}
		| INTGR INTGR name
		{	$$ = Parse_Link( $1, $2, $3 );
		}
                ;
		*/

one_link_descr : address
		{	$$ = Parse_Link( $1, 1, "" );
		}
		| address INTGR
		{	$$ = Parse_Link( $1, $2, "" );
		}
		| address name
		{	$$ = Parse_Link( $1, 1, $2 );
		}
		| address INTGR name
		{	$$ = Parse_Link( $1, $2, $3 );
		}
                ;

io_address :	IN INTGR
		{
			$$ = Parse_Address( 'I', $2, (Address)NULL );
		}
		| OUT INTGR
		{
			$$ = Parse_Address( 'O', $2, (Address)NULL );
		}
		;

address :	SUBMO INTGR SLASH io_address
		{
			$$ = Parse_Address( 'S', $2, $4 );
		}
	 	| PLACE INTGR 
		{
			$$ = Parse_Address( 'P', $2, (Address)NULL );
		}
		| TRANS INTGR
		{
			$$ = Parse_Address( 'T', $2, (Address)NULL );
		}
		| INTGR
		{
			$$ = Parse_Address( 'U', $1, (Address)NULL );
		}
		;

address_list :	address
		{
			$$ = Append_Address( $1, (Liste_Address)NULL );
		}
		| address_list address
		{
			$$ = Append_Address( $2, $1 );
		}
		| /* empty */
		{
			$$ = (Liste_Address)NULL;
		}
		;

binding_dcl :	/* BIND */ binding_list
		{
		        $$ = $1;
		}
		| /* nul */
		{
		  	$$ = (Binding) NULL;
		}
		;

binding_list :	binding_list a_binding
		{
			$$ = Append_Binding( $1, $2 );
		}
		|
		a_binding
		{
			$$ = Append_Binding( $1, (Binding)NULL );
		}
/* 		| */
/* 		{ */
/* 			$$ = (Binding) NULL; */
/* 		} */
		;

a_binding :	SUBMO INTGR SLASH io_address SEP link_list ENDINSTR
		{
			$$ = Parse_Binding( $2, $4, $6 );
		}
		;


%%
#include "pnl_lex.yy.c"
