/* Structures de donnees pour les programmes/modules d'etude de 	*/
/* graphes de taches 							*/

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

#include "version.h"
#include "boolean.h"
#include "law.h"
#include "parseargs.h"

extern boolean Debug;

/************************************************************************/
/* definitions de types pour liens et synchros				*/
typedef	int	LType;

#define	PRECEDENCE	1
#define	ITERATION	2
#define	EXCLUSION	3

typedef int	SType;

#define	AND		1
#define	OR		2

/************************************************************************/
typedef struct Parametres {
	int	Size;
	int	Nb_Events;
} Parametres;

typedef struct LINK_DESC {
	int		Link_Id;
	char		*Link_Name;
	LType		Link_Type;
	SType		Synchro_Type;
	int		Task_From;
	int		Task_To;	/* numero tache en sortie 	*/
	Law_Desc	Link_Law;
	int		Depth;		/* niveau dependence si pgm	*/
	double		Val;		/* value timing (after sampling)*/
	boolean		Is_Critical;
} *Link_Desc;

typedef struct LAYER_DESC {
	int	Nb_Tasks;
	int	*Task_Id;
} *Layer_Desc;

typedef struct LINK_LIST {
	Link_Desc 	Val;
	struct LINK_LIST *Next;
} *Liste_Link;

typedef struct TASK {
	int		Task_Id;	/* no numero			*/
	char		*Task_Name;
	char		*Task_Given_Name;
	Law_Desc	Task_Law;
	Liste_Link	Neighbors;	/* liste des liens sortant	*/
	Layer_Desc	Prev;		/* liste des taches amont	*/
	boolean		Is_Critical;

} Task;

typedef struct Graph {
	int		Size;
	int		Nb_Events;	/* a cet endroit provisoirement	*/
	Task		*T;		/* tableau des noeuds		*/
	Layer_Desc	*Level;		/* structure en couches 	*/
	int		Nb_Layers;
	int		Max_Dependency;
} Graph;

typedef struct TASK_LIST {
	Task 	*Val;
	struct TASK_LIST *Next;
} *Liste_Task;

/* utile au parsing seulement */
typedef struct BIPOINT {
        int     Origin;
	int     Destination;
} *BiPoint;

typedef struct OBJ_LIST {
	Link_Desc	A_Link;
	Task		*A_Task;
	struct OBJ_LIST *Next;
} *Liste_Object;

#define SCAN( x, y )	for( x=y; x!=NULL; x=x->Next )
