/* un programme juste pour lire un tg et en faire l'analyse		*/


#include <stdio.h>
#include "version.h"
#include "taskgraph.h"
#include "parseargs.h"

#define TOOLNAME	"tg_read"

extern Graph		*Read_Network(char *File_Name);
extern boolean		topological_analysis(Graph *Reseau);
extern void		dumpe_network(Graph *Reseau);
extern void		Free_Task_Graph(Graph *Reseau);
extern boolean		Parse_Debug;


int main(int argc, char *argv[])
{	
  static char	File_Name[128] = "";
  Graph 	*Reseau;
  int		i;
  boolean	Help = FALSE;
  boolean	Args_Ok = TRUE;
    
  i = 1;
    
  if (argc>1)
    do {
      if GET_STRING( "-f", File_Name )
      else if IS_VERSION		     

      else if ( ( 0 == strcmp( "-h", argv[i] ) )
		|| ( 0 == strcmp( "-?", argv[i] ) ) ) {
	printf("Usage: %s [-f <file>] [-?] [-h]\n", TOOLNAME );
	Args_Ok = FALSE;
	Help = TRUE;
	i++;
      }
      else
	i++; /* skip unknown argument */
    }
    while ( Args_Ok && ( i < argc ) );
    
  if (Args_Ok) {
	
    Parse_Debug = TRUE;

    Reseau = Read_Network( File_Name );

    if ( Reseau != NULL ) {

      topological_analysis(Reseau);
      /* invert_network(Reseau); */
      dumpe_network(Reseau);

      Free_Task_Graph( Reseau );

      return 0;
    }
    else {
      printf("%s: error: could not read graph from file %s.\n",
	     TOOLNAME, File_Name );
      return -1;
    }
  }
  else if (!Help) {
    return -1;
  }
  else
    return 0;
}
