#	Test if the widget has a normal configuration
#       Return 1 if normal, 0 else
proc normal {w} {
    return [string match {normal} [lindex [${w} conf -state] 4]]
}


#	Insert the text which is selected by mouse
#       So permit cut/paste with all windows
proc emacsInsertSelect {ent} {
    if {[normal $ent] && ![catch {selection get} bf] && \
      ![string match ""  $bf]} {
	# insert text
        $ent insert insert $bf

	# look at cursor
        tk_entrySeeCaret $ent
    }
}


#	Create an entry widget with emacs binding
proc emacsEntry {args} {
    # the entry widget
    set name [eval entry $args -insertofftime 0]
    
    # binding at emacs style
#    bind $name <Enter>	 { focus %W}
#    bind $name <Leave>	 { focus ""}
#     bind $name <Control-a> { 
# 	%W icursor 0; tk_entrySeeCaret %W }
#     bind $name <Control-b> { 
# 	%W icursor [expr {[%W index insert] - 1}]; tk_entrySeeCaret %W}
#     bind $name <Left> { 
# 	%W icursor [expr {[%W index insert]- 1}]; tk_entrySeeCaret %W}
#     bind $name <Control-d> { 
# 	%W delete insert; tk_entrySeeCaret %W}
#     bind $name <Control-e> {
# 	%W icursor end; tk_entrySeeCaret %W }
#     bind $name <Control-f> { 
# 	%W icursor [expr {[%W index insert] + 1}]; tk_entrySeeCaret %W}
#     bind $name <Right> {
# 	%W icursor [expr {[%W index insert]+ 1}]; tk_entrySeeCaret %W}
#     bind $name <Control-k> { 
# 	%W delete insert end; tk_entrySeeCaret %W}
#     bind $name <ButtonPress-2> {
# 	emacsInsertSelect %W; tk_entrySeeCaret %W}
#     bind $name <Delete> {
# 	tk_entryBackspace %W; tk_entrySeeCaret %W}
#     bind $name <BackSpace> {
# 	tk_entryBackspace %W; tk_entrySeeCaret %W}
}


#	Create a text widget with emacs binding
proc EmacsText {args} {
    # the widget
    set name [eval text $args -insertofftime 0]

    # binding ...
    # Updated 06/09/1994
#    bind $name <Enter>	 { focus %W}
#    bind $name <Leave>	 { focus ""}
    bind $name <Left> {
	set tk_priv(CutBufferMove) 1
	%W mark set insert insert-1c; %W yview -pickplace insert }
    bind $name <Right> {
	set tk_priv(CutBufferMove) 1
	%W mark set insert insert+1c; %W yview -pickplace insert }
    bind $name <Up> {
	set tk_priv(CutBufferMove) 1
	%W mark set insert insert-1l; %W yview -pickplace insert }
    bind $name <Down> {
	set tk_priv(CutBufferMove) 1
	%W mark set insert insert+1l; %W yview -pickplace insert }
    bind $name <Delete> {
	set tk_priv(CutBufferMove) 1
	tk_textBackspace %W; %W yview -pickplace insert }
    bind $name <Control-a> {
	set tk_priv(CutBufferMove) 1
	%W mark set insert "insert linestart"; %W yview -pickplace insert }
    bind $name <Control-b> {
	set tk_priv(CutBufferMove) 1
	%W mark set insert insert-1c; %W yview -pickplace insert }
    bind $name <Control-d> {
	set tk_priv(CutBufferMove) 1
	%W delete insert insert+1c; %W yview -pickplace insert }
    bind $name <Control-e> {
	set tk_priv(CutBufferMove) 1
	%W mark set insert "insert lineend"; %W yview -pickplace insert }
    bind $name <Control-f> {
	set tk_priv(CutBufferMove) 1
	%W mark set insert insert+1c; %W yview -pickplace insert }
    bind $name <Control-n> {
	set tk_priv(CutBufferMove) 1
	%W mark set insert insert+1l; %W yview -pickplace insert}
    bind $name <Control-p> {
	set tk_priv(CutBufferMove) 1
	%W mark set insert insert-1l; %W yview -pickplace insert}
    bind $name <Home> {
	set tk_priv(CutBufferMove) 1
	%W mark set insert 1.0; %W yview -pickplace insert}
    bind $name <End> {
	set tk_priv(CutBufferMove) 1
	%W mark set insert end; %W yview -pickplace insert}
    bind $name <Prior> {
	set tk_priv(CutBufferMove) 1
	set Count [lindex [%W config -height] 4]
	while {$Count > 0} {
	    %W mark set insert insert-1l
	    incr Count -1
	}
	%W yview -pickplace insert}
    bind $name <Next> {
	set tk_priv(CutBufferMove) 1
	set Count [lindex [%W config -height] 4]
	while {$Count > 0} {
	    %W mark set insert insert+1l
	    incr Count -1
	}
	%W yview -pickplace insert}
    bind $name <Button-3> {
	%W insert insert "[selection get]"; %W yview -pickplace insert}
    bind $name <Control-y> {
	if { [info exists tk_priv(CutBuffer)] } {
	    %W insert insert "$tk_priv(CutBuffer)"
	}
	%W yview -pickplace insert}
    bind $name <Control-w> {
	if { $tk_priv(CutBufferMove) } {
	    set tk_priv(CutBuffer) [%W get sel.first sel.last]
	    set tk_priv(CutBufferMove) 0
	} else {
	    append tk_priv(CutBuffer) [%W get sel.first sel.last]
	}
	catch "%W delete sel.first sel.last"}
    bind $name <Control-k> {
	if {[%W compare insert == "insert lineend"]} {
	    if { $tk_priv(CutBufferMove) } {
		set tk_priv(CutBuffer) "\n"
		set tk_priv(CutBufferMove) 0
	    } else {
		append tk_priv(CutBuffer) "\n"
	    }
	    %W delete insert "insert lineend +1c"
	    %W yview -pickplace insert
	} else {
	    if { $tk_priv(CutBufferMove) } {
		set tk_priv(CutBuffer) [%W get insert "insert lineend"]
		set tk_priv(CutBufferMove) 0
	    } else {
		append tk_priv(CutBuffer) [%W get insert "insert lineend"]
	    }
	    %W delete insert "insert lineend"
	    %W yview -pickplace insert}}
}

#   Bindings that are used for the tabulation in the directory
#    path name entry
proc BindTab { widget } {
    bind $widget <Control-a> +ResetTab 
    bind $widget <Control-b> +ResetTab
    bind $widget <Left> +ResetTab
    bind $widget <Control-d> +ResetTab
    bind $widget <Control-e> +ResetTab
    bind $widget <Control-f> +ResetTab
    bind $widget <Right> +ResetTab
    bind $widget <Control-k> +ResetTab
    bind $widget <Control-u> +ResetTab
    bind $widget <ButtonPress-2> +ResetTab
    bind $widget <Delete> +ResetTab
    bind $widget <BackSpace> +ResetTab
    bind $widget <Control-h> +ResetTab
    bind $widget <slash> { %W insert insert "/"; ResetTab; tk_entrySeeCaret %W
    }
    bind $widget <Tab> { SearchPath; tk_entrySeeCaret %W }
}


